/* ***********************************************************
 * This file was automatically generated on 2024-02-27.      *
 *                                                           *
 * Rust Bindings Version 2.0.21                              *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

//! Breakout for Infineon XMC1400 microcontroller.
//!
//! See also the documentation [here](https://www.tinkerforge.com/en/doc/Software/Bricklets/XMC1400Breakout_Bricklet_Rust.html).
use crate::{
    byte_converter::*, converting_callback_receiver::ConvertingCallbackReceiver, converting_receiver::ConvertingReceiver, device::*,
    ip_connection::GetRequestSender,
};
pub enum Xmc1400BreakoutBrickletFunction {
    SetGpioConfig,
    GetGpioInput,
    SetAdcChannelConfig,
    GetAdcChannelConfig,
    GetAdcChannelValue,
    GetAdcValues,
    SetAdcValuesCallbackConfiguration,
    GetAdcValuesCallbackConfiguration,
    GetCount,
    SetCountCallbackConfiguration,
    GetCountCallbackConfiguration,
    GetSpitfpErrorCount,
    SetBootloaderMode,
    GetBootloaderMode,
    SetWriteFirmwarePointer,
    WriteFirmware,
    SetStatusLedConfig,
    GetStatusLedConfig,
    GetChipTemperature,
    Reset,
    WriteUid,
    ReadUid,
    GetIdentity,
    CallbackAdcValues,
    CallbackCount,
}
impl From<Xmc1400BreakoutBrickletFunction> for u8 {
    fn from(fun: Xmc1400BreakoutBrickletFunction) -> Self {
        match fun {
            Xmc1400BreakoutBrickletFunction::SetGpioConfig => 1,
            Xmc1400BreakoutBrickletFunction::GetGpioInput => 2,
            Xmc1400BreakoutBrickletFunction::SetAdcChannelConfig => 3,
            Xmc1400BreakoutBrickletFunction::GetAdcChannelConfig => 4,
            Xmc1400BreakoutBrickletFunction::GetAdcChannelValue => 5,
            Xmc1400BreakoutBrickletFunction::GetAdcValues => 6,
            Xmc1400BreakoutBrickletFunction::SetAdcValuesCallbackConfiguration => 7,
            Xmc1400BreakoutBrickletFunction::GetAdcValuesCallbackConfiguration => 8,
            Xmc1400BreakoutBrickletFunction::GetCount => 10,
            Xmc1400BreakoutBrickletFunction::SetCountCallbackConfiguration => 11,
            Xmc1400BreakoutBrickletFunction::GetCountCallbackConfiguration => 12,
            Xmc1400BreakoutBrickletFunction::GetSpitfpErrorCount => 234,
            Xmc1400BreakoutBrickletFunction::SetBootloaderMode => 235,
            Xmc1400BreakoutBrickletFunction::GetBootloaderMode => 236,
            Xmc1400BreakoutBrickletFunction::SetWriteFirmwarePointer => 237,
            Xmc1400BreakoutBrickletFunction::WriteFirmware => 238,
            Xmc1400BreakoutBrickletFunction::SetStatusLedConfig => 239,
            Xmc1400BreakoutBrickletFunction::GetStatusLedConfig => 240,
            Xmc1400BreakoutBrickletFunction::GetChipTemperature => 242,
            Xmc1400BreakoutBrickletFunction::Reset => 243,
            Xmc1400BreakoutBrickletFunction::WriteUid => 248,
            Xmc1400BreakoutBrickletFunction::ReadUid => 249,
            Xmc1400BreakoutBrickletFunction::GetIdentity => 255,
            Xmc1400BreakoutBrickletFunction::CallbackAdcValues => 9,
            Xmc1400BreakoutBrickletFunction::CallbackCount => 13,
        }
    }
}
pub const XMC1400_BREAKOUT_BRICKLET_THRESHOLD_OPTION_OFF: char = 'x';
pub const XMC1400_BREAKOUT_BRICKLET_THRESHOLD_OPTION_OUTSIDE: char = 'o';
pub const XMC1400_BREAKOUT_BRICKLET_THRESHOLD_OPTION_INSIDE: char = 'i';
pub const XMC1400_BREAKOUT_BRICKLET_THRESHOLD_OPTION_SMALLER: char = '<';
pub const XMC1400_BREAKOUT_BRICKLET_THRESHOLD_OPTION_GREATER: char = '>';
pub const XMC1400_BREAKOUT_BRICKLET_GPIO_MODE_INPUT_TRISTATE: u8 = 0;
pub const XMC1400_BREAKOUT_BRICKLET_GPIO_MODE_INPUT_PULL_DOWN: u8 = 1;
pub const XMC1400_BREAKOUT_BRICKLET_GPIO_MODE_INPUT_PULL_UP: u8 = 2;
pub const XMC1400_BREAKOUT_BRICKLET_GPIO_MODE_INPUT_SAMPLING: u8 = 3;
pub const XMC1400_BREAKOUT_BRICKLET_GPIO_MODE_INPUT_INVERTED_TRISTATE: u8 = 4;
pub const XMC1400_BREAKOUT_BRICKLET_GPIO_MODE_INPUT_INVERTED_PULL_DOWN: u8 = 5;
pub const XMC1400_BREAKOUT_BRICKLET_GPIO_MODE_INPUT_INVERTED_PULL_UP: u8 = 6;
pub const XMC1400_BREAKOUT_BRICKLET_GPIO_MODE_INPUT_INVERTED_SAMPLING: u8 = 7;
pub const XMC1400_BREAKOUT_BRICKLET_GPIO_MODE_OUTPUT_PUSH_PULL: u8 = 8;
pub const XMC1400_BREAKOUT_BRICKLET_GPIO_MODE_OUTPUT_OPEN_DRAIN: u8 = 9;
pub const XMC1400_BREAKOUT_BRICKLET_GPIO_INPUT_HYSTERESIS_STANDARD: u8 = 0;
pub const XMC1400_BREAKOUT_BRICKLET_GPIO_INPUT_HYSTERESIS_LARGE: u8 = 4;
pub const XMC1400_BREAKOUT_BRICKLET_BOOTLOADER_MODE_BOOTLOADER: u8 = 0;
pub const XMC1400_BREAKOUT_BRICKLET_BOOTLOADER_MODE_FIRMWARE: u8 = 1;
pub const XMC1400_BREAKOUT_BRICKLET_BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT: u8 = 2;
pub const XMC1400_BREAKOUT_BRICKLET_BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT: u8 = 3;
pub const XMC1400_BREAKOUT_BRICKLET_BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT: u8 = 4;
pub const XMC1400_BREAKOUT_BRICKLET_BOOTLOADER_STATUS_OK: u8 = 0;
pub const XMC1400_BREAKOUT_BRICKLET_BOOTLOADER_STATUS_INVALID_MODE: u8 = 1;
pub const XMC1400_BREAKOUT_BRICKLET_BOOTLOADER_STATUS_NO_CHANGE: u8 = 2;
pub const XMC1400_BREAKOUT_BRICKLET_BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT: u8 = 3;
pub const XMC1400_BREAKOUT_BRICKLET_BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT: u8 = 4;
pub const XMC1400_BREAKOUT_BRICKLET_BOOTLOADER_STATUS_CRC_MISMATCH: u8 = 5;
pub const XMC1400_BREAKOUT_BRICKLET_STATUS_LED_CONFIG_OFF: u8 = 0;
pub const XMC1400_BREAKOUT_BRICKLET_STATUS_LED_CONFIG_ON: u8 = 1;
pub const XMC1400_BREAKOUT_BRICKLET_STATUS_LED_CONFIG_SHOW_HEARTBEAT: u8 = 2;
pub const XMC1400_BREAKOUT_BRICKLET_STATUS_LED_CONFIG_SHOW_STATUS: u8 = 3;

#[derive(Clone, Copy, Debug, Default, PartialEq, Eq, Hash)]
pub struct AdcValuesCallbackConfiguration {
    pub period: u32,
    pub value_has_to_change: bool,
}
impl FromByteSlice for AdcValuesCallbackConfiguration {
    fn bytes_expected() -> usize { 5 }
    fn from_le_byte_slice(bytes: &[u8]) -> AdcValuesCallbackConfiguration {
        AdcValuesCallbackConfiguration {
            period: <u32>::from_le_byte_slice(&bytes[0..4]),
            value_has_to_change: <bool>::from_le_byte_slice(&bytes[4..5]),
        }
    }
}

#[derive(Clone, Copy, Debug, Default, PartialEq, Eq, Hash)]
pub struct CountCallbackConfiguration {
    pub period: u32,
    pub value_has_to_change: bool,
    pub option: char,
    pub min: u32,
    pub max: u32,
}
impl FromByteSlice for CountCallbackConfiguration {
    fn bytes_expected() -> usize { 14 }
    fn from_le_byte_slice(bytes: &[u8]) -> CountCallbackConfiguration {
        CountCallbackConfiguration {
            period: <u32>::from_le_byte_slice(&bytes[0..4]),
            value_has_to_change: <bool>::from_le_byte_slice(&bytes[4..5]),
            option: <char>::from_le_byte_slice(&bytes[5..6]),
            min: <u32>::from_le_byte_slice(&bytes[6..10]),
            max: <u32>::from_le_byte_slice(&bytes[10..14]),
        }
    }
}

#[derive(Clone, Copy, Debug, Default, PartialEq, Eq, Hash)]
pub struct SpitfpErrorCount {
    pub error_count_ack_checksum: u32,
    pub error_count_message_checksum: u32,
    pub error_count_frame: u32,
    pub error_count_overflow: u32,
}
impl FromByteSlice for SpitfpErrorCount {
    fn bytes_expected() -> usize { 16 }
    fn from_le_byte_slice(bytes: &[u8]) -> SpitfpErrorCount {
        SpitfpErrorCount {
            error_count_ack_checksum: <u32>::from_le_byte_slice(&bytes[0..4]),
            error_count_message_checksum: <u32>::from_le_byte_slice(&bytes[4..8]),
            error_count_frame: <u32>::from_le_byte_slice(&bytes[8..12]),
            error_count_overflow: <u32>::from_le_byte_slice(&bytes[12..16]),
        }
    }
}

#[derive(Clone, Debug, Default, PartialEq, Eq, Hash)]
pub struct Identity {
    pub uid: String,
    pub connected_uid: String,
    pub position: char,
    pub hardware_version: [u8; 3],
    pub firmware_version: [u8; 3],
    pub device_identifier: u16,
}
impl FromByteSlice for Identity {
    fn bytes_expected() -> usize { 25 }
    fn from_le_byte_slice(bytes: &[u8]) -> Identity {
        Identity {
            uid: <String>::from_le_byte_slice(&bytes[0..8]),
            connected_uid: <String>::from_le_byte_slice(&bytes[8..16]),
            position: <char>::from_le_byte_slice(&bytes[16..17]),
            hardware_version: <[u8; 3]>::from_le_byte_slice(&bytes[17..20]),
            firmware_version: <[u8; 3]>::from_le_byte_slice(&bytes[20..23]),
            device_identifier: <u16>::from_le_byte_slice(&bytes[23..25]),
        }
    }
}

/// Breakout for Infineon XMC1400 microcontroller
#[derive(Clone)]
pub struct Xmc1400BreakoutBricklet {
    device: Device,
}
impl Xmc1400BreakoutBricklet {
    pub const DEVICE_IDENTIFIER: u16 = 279;
    pub const DEVICE_DISPLAY_NAME: &'static str = "XMC1400 Breakout Bricklet";
    /// Creates an object with the unique device ID `uid`. This object can then be used after the IP Connection `ip_connection` is connected.
    pub fn new<T: GetRequestSender>(uid: &str, req_sender: T) -> Xmc1400BreakoutBricklet {
        let mut result = Xmc1400BreakoutBricklet { device: Device::new([2, 0, 0], uid, req_sender, 0) };
        result.device.response_expected[u8::from(Xmc1400BreakoutBrickletFunction::SetGpioConfig) as usize] = ResponseExpectedFlag::False;
        result.device.response_expected[u8::from(Xmc1400BreakoutBrickletFunction::GetGpioInput) as usize] =
            ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(Xmc1400BreakoutBrickletFunction::SetAdcChannelConfig) as usize] =
            ResponseExpectedFlag::False;
        result.device.response_expected[u8::from(Xmc1400BreakoutBrickletFunction::GetAdcChannelConfig) as usize] =
            ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(Xmc1400BreakoutBrickletFunction::GetAdcChannelValue) as usize] =
            ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(Xmc1400BreakoutBrickletFunction::GetAdcValues) as usize] =
            ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(Xmc1400BreakoutBrickletFunction::SetAdcValuesCallbackConfiguration) as usize] =
            ResponseExpectedFlag::True;
        result.device.response_expected[u8::from(Xmc1400BreakoutBrickletFunction::GetAdcValuesCallbackConfiguration) as usize] =
            ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(Xmc1400BreakoutBrickletFunction::GetCount) as usize] = ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(Xmc1400BreakoutBrickletFunction::SetCountCallbackConfiguration) as usize] =
            ResponseExpectedFlag::True;
        result.device.response_expected[u8::from(Xmc1400BreakoutBrickletFunction::GetCountCallbackConfiguration) as usize] =
            ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(Xmc1400BreakoutBrickletFunction::GetSpitfpErrorCount) as usize] =
            ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(Xmc1400BreakoutBrickletFunction::SetBootloaderMode) as usize] =
            ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(Xmc1400BreakoutBrickletFunction::GetBootloaderMode) as usize] =
            ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(Xmc1400BreakoutBrickletFunction::SetWriteFirmwarePointer) as usize] =
            ResponseExpectedFlag::False;
        result.device.response_expected[u8::from(Xmc1400BreakoutBrickletFunction::WriteFirmware) as usize] =
            ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(Xmc1400BreakoutBrickletFunction::SetStatusLedConfig) as usize] =
            ResponseExpectedFlag::False;
        result.device.response_expected[u8::from(Xmc1400BreakoutBrickletFunction::GetStatusLedConfig) as usize] =
            ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(Xmc1400BreakoutBrickletFunction::GetChipTemperature) as usize] =
            ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(Xmc1400BreakoutBrickletFunction::Reset) as usize] = ResponseExpectedFlag::False;
        result.device.response_expected[u8::from(Xmc1400BreakoutBrickletFunction::WriteUid) as usize] = ResponseExpectedFlag::False;
        result.device.response_expected[u8::from(Xmc1400BreakoutBrickletFunction::ReadUid) as usize] = ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(Xmc1400BreakoutBrickletFunction::GetIdentity) as usize] = ResponseExpectedFlag::AlwaysTrue;
        result
    }

    /// Returns the response expected flag for the function specified by the function ID parameter.
    /// It is true if the function is expected to send a response, false otherwise.
    ///
    /// For getter functions this is enabled by default and cannot be disabled, because those
    /// functions will always send a response. For callback configuration functions it is enabled
    /// by default too, but can be disabled by [`set_response_expected`](crate::xmc1400_breakout_bricklet::Xmc1400BreakoutBricklet::set_response_expected).
    /// For setter functions it is disabled by default and can be enabled.
    ///
    /// Enabling the response expected flag for a setter function allows to detect timeouts
    /// and other error conditions calls of this setter as well. The device will then send a response
    /// for this purpose. If this flag is disabled for a setter function then no response is sent
    /// and errors are silently ignored, because they cannot be detected.
    ///
    /// See [`set_response_expected`](crate::xmc1400_breakout_bricklet::Xmc1400BreakoutBricklet::set_response_expected) for the list of function ID constants available for this function.
    pub fn get_response_expected(&mut self, fun: Xmc1400BreakoutBrickletFunction) -> Result<bool, GetResponseExpectedError> {
        self.device.get_response_expected(u8::from(fun))
    }

    /// Changes the response expected flag of the function specified by the function ID parameter.
    /// This flag can only be changed for setter (default value: false) and callback configuration
    /// functions (default value: true). For getter functions it is always enabled.
    ///
    /// Enabling the response expected flag for a setter function allows to detect timeouts and
    /// other error conditions calls of this setter as well. The device will then send a response
    /// for this purpose. If this flag is disabled for a setter function then no response is sent
    /// and errors are silently ignored, because they cannot be detected.
    pub fn set_response_expected(
        &mut self,
        fun: Xmc1400BreakoutBrickletFunction,
        response_expected: bool,
    ) -> Result<(), SetResponseExpectedError> {
        self.device.set_response_expected(u8::from(fun), response_expected)
    }

    /// Changes the response expected flag for all setter and callback configuration functions of this device at once.
    pub fn set_response_expected_all(&mut self, response_expected: bool) { self.device.set_response_expected_all(response_expected) }

    /// Returns the version of the API definition (major, minor, revision) implemented by this API bindings.
    /// This is neither the release version of this API bindings nor does it tell you anything about the represented Brick or Bricklet.
    pub fn get_api_version(&self) -> [u8; 3] { self.device.api_version }

    /// This receiver is triggered periodically according to the configuration set by
    /// [`set_adc_values_callback_configuration`].
    ///
    /// The parameters are the same as [`get_adc_values`].
    ///
    /// [`get_adc_values`]: #method.get_adc_values
    /// [`set_adc_values_callback_configuration`]: #method.set_adc_values_callback_configuration
    pub fn get_adc_values_callback_receiver(&self) -> ConvertingCallbackReceiver<[u16; 8]> {
        self.device.get_callback_receiver(u8::from(Xmc1400BreakoutBrickletFunction::CallbackAdcValues))
    }

    /// This receiver is triggered periodically according to the configuration set by
    /// [`set_count_callback_configuration`].
    ///
    /// The parameter is the same as [`get_count`].
    pub fn get_count_callback_receiver(&self) -> ConvertingCallbackReceiver<u32> {
        self.device.get_callback_receiver(u8::from(Xmc1400BreakoutBrickletFunction::CallbackCount))
    }

    /// Example for a setter function. The values are the values that can be given to
    /// the XMC_GPIO_Init function. See communication.c in the firmware.
    ///
    /// Associated constants:
    /// * XMC1400_BREAKOUT_BRICKLET_GPIO_MODE_INPUT_TRISTATE
    ///	* XMC1400_BREAKOUT_BRICKLET_GPIO_MODE_INPUT_PULL_DOWN
    ///	* XMC1400_BREAKOUT_BRICKLET_GPIO_MODE_INPUT_PULL_UP
    ///	* XMC1400_BREAKOUT_BRICKLET_GPIO_MODE_INPUT_SAMPLING
    ///	* XMC1400_BREAKOUT_BRICKLET_GPIO_MODE_INPUT_INVERTED_TRISTATE
    ///	* XMC1400_BREAKOUT_BRICKLET_GPIO_MODE_INPUT_INVERTED_PULL_DOWN
    ///	* XMC1400_BREAKOUT_BRICKLET_GPIO_MODE_INPUT_INVERTED_PULL_UP
    ///	* XMC1400_BREAKOUT_BRICKLET_GPIO_MODE_INPUT_INVERTED_SAMPLING
    ///	* XMC1400_BREAKOUT_BRICKLET_GPIO_MODE_OUTPUT_PUSH_PULL
    ///	* XMC1400_BREAKOUT_BRICKLET_GPIO_MODE_OUTPUT_OPEN_DRAIN
    ///	* XMC1400_BREAKOUT_BRICKLET_GPIO_INPUT_HYSTERESIS_STANDARD
    ///	* XMC1400_BREAKOUT_BRICKLET_GPIO_INPUT_HYSTERESIS_LARGE
    pub fn set_gpio_config(&self, port: u8, pin: u8, mode: u8, input_hysteresis: u8, output_level: bool) -> ConvertingReceiver<()> {
        let mut payload = vec![0; 5];
        payload[0..1].copy_from_slice(&<u8>::to_le_byte_vec(port));
        payload[1..2].copy_from_slice(&<u8>::to_le_byte_vec(pin));
        payload[2..3].copy_from_slice(&<u8>::to_le_byte_vec(mode));
        payload[3..4].copy_from_slice(&<u8>::to_le_byte_vec(input_hysteresis));
        payload[4..5].copy_from_slice(&<bool>::to_le_byte_vec(output_level));

        self.device.set(u8::from(Xmc1400BreakoutBrickletFunction::SetGpioConfig), payload)
    }

    /// Example for a getter function. Returns the result of a
    /// XMC_GPIO_GetInput call for the given port/pin.
    pub fn get_gpio_input(&self, port: u8, pin: u8) -> ConvertingReceiver<bool> {
        let mut payload = vec![0; 2];
        payload[0..1].copy_from_slice(&<u8>::to_le_byte_vec(port));
        payload[1..2].copy_from_slice(&<u8>::to_le_byte_vec(pin));

        self.device.get(u8::from(Xmc1400BreakoutBrickletFunction::GetGpioInput), payload)
    }

    /// Enables a ADC channel for the ADC driver example (adc.c/adc.h).
    ///
    /// There are 8 ADC channels and they correspond to the following pins:
    ///
    /// * Channel 0: P2_6
    /// * Channel 1: P2_8
    /// * Channel 2: P2_9
    /// * Channel 3: P2_10
    /// * Channel 4: P2_11
    /// * Channel 5: P2_0
    /// * Channel 6: P2_1
    /// * Channel 7: P2_2
    pub fn set_adc_channel_config(&self, channel: u8, enable: bool) -> ConvertingReceiver<()> {
        let mut payload = vec![0; 2];
        payload[0..1].copy_from_slice(&<u8>::to_le_byte_vec(channel));
        payload[1..2].copy_from_slice(&<bool>::to_le_byte_vec(enable));

        self.device.set(u8::from(Xmc1400BreakoutBrickletFunction::SetAdcChannelConfig), payload)
    }

    /// Returns the config for the given channel as set by [`set_adc_channel_config`].
    pub fn get_adc_channel_config(&self, channel: u8) -> ConvertingReceiver<bool> {
        let mut payload = vec![0; 1];
        payload[0..1].copy_from_slice(&<u8>::to_le_byte_vec(channel));

        self.device.get(u8::from(Xmc1400BreakoutBrickletFunction::GetAdcChannelConfig), payload)
    }

    /// Returns the 12-bit value of the given ADC channel of the ADC driver example.
    pub fn get_adc_channel_value(&self, channel: u8) -> ConvertingReceiver<u16> {
        let mut payload = vec![0; 1];
        payload[0..1].copy_from_slice(&<u8>::to_le_byte_vec(channel));

        self.device.get(u8::from(Xmc1400BreakoutBrickletFunction::GetAdcChannelValue), payload)
    }

    /// Returns the values for all 8 ADC channels of the adc driver example.
    ///
    /// This example function also has a corresponding receiver.
    ///
    /// See [`set_adc_values_callback_configuration`] and [`get_adc_values_callback_receiver`] receiver.
    pub fn get_adc_values(&self) -> ConvertingReceiver<[u16; 8]> {
        let payload = vec![0; 0];

        self.device.get(u8::from(Xmc1400BreakoutBrickletFunction::GetAdcValues), payload)
    }

    /// The period is the period with which the [`get_adc_values_callback_receiver`]
    /// receiver is triggered periodically. A value of 0 turns the receiver off.
    ///
    /// If the `value has to change`-parameter is set to true, the receiver is only
    /// triggered after the value has changed. If the value didn't change within the
    /// period, the receiver is triggered immediately on change.
    ///
    /// If it is set to false, the receiver is continuously triggered with the period,
    /// independent of the value.
    pub fn set_adc_values_callback_configuration(&self, period: u32, value_has_to_change: bool) -> ConvertingReceiver<()> {
        let mut payload = vec![0; 5];
        payload[0..4].copy_from_slice(&<u32>::to_le_byte_vec(period));
        payload[4..5].copy_from_slice(&<bool>::to_le_byte_vec(value_has_to_change));

        self.device.set(u8::from(Xmc1400BreakoutBrickletFunction::SetAdcValuesCallbackConfiguration), payload)
    }

    /// Returns the receiver configuration as set by
    /// [`set_adc_values_callback_configuration`].
    pub fn get_adc_values_callback_configuration(&self) -> ConvertingReceiver<AdcValuesCallbackConfiguration> {
        let payload = vec![0; 0];

        self.device.get(u8::from(Xmc1400BreakoutBrickletFunction::GetAdcValuesCallbackConfiguration), payload)
    }

    /// Returns the value of the example count (see example.c).
    ///
    /// This example function uses the add_callback_value_function-helper in the
    /// generator. The getter as well as the receiver and receiver configuration
    /// functions are auto-generated for the API as well as the firmware.
    ///
    ///
    /// If you want to get the value periodically, it is recommended to use the
    /// [`get_count_callback_receiver`] receiver. You can set the receiver configuration
    /// with [`set_count_callback_configuration`].
    pub fn get_count(&self) -> ConvertingReceiver<u32> {
        let payload = vec![0; 0];

        self.device.get(u8::from(Xmc1400BreakoutBrickletFunction::GetCount), payload)
    }

    /// The period is the period with which the [`get_count_callback_receiver`] receiver is triggered
    /// periodically. A value of 0 turns the receiver off.
    ///
    /// If the `value has to change`-parameter is set to true, the receiver is only
    /// triggered after the value has changed. If the value didn't change
    /// within the period, the receiver is triggered immediately on change.
    ///
    /// If it is set to false, the receiver is continuously triggered with the period,
    /// independent of the value.
    ///
    /// It is furthermore possible to constrain the receiver with thresholds.
    ///
    /// The `option`-parameter together with min/max sets a threshold for the [`get_count_callback_receiver`] receiver.
    ///
    /// The following options are possible:
    ///
    ///  Option| Description
    ///  --- | ---
    ///  'x'|    Threshold is turned off
    ///  'o'|    Threshold is triggered when the value is *outside* the min and max values
    ///  'i'|    Threshold is triggered when the value is *inside* or equal to the min and max values
    ///  '<'|    Threshold is triggered when the value is smaller than the min value (max is ignored)
    ///  '>'|    Threshold is triggered when the value is greater than the min value (max is ignored)
    ///
    /// If the option is set to 'x' (threshold turned off) the receiver is triggered with the fixed period.
    ///
    /// Associated constants:
    /// * XMC1400_BREAKOUT_BRICKLET_THRESHOLD_OPTION_OFF
    ///	* XMC1400_BREAKOUT_BRICKLET_THRESHOLD_OPTION_OUTSIDE
    ///	* XMC1400_BREAKOUT_BRICKLET_THRESHOLD_OPTION_INSIDE
    ///	* XMC1400_BREAKOUT_BRICKLET_THRESHOLD_OPTION_SMALLER
    ///	* XMC1400_BREAKOUT_BRICKLET_THRESHOLD_OPTION_GREATER
    pub fn set_count_callback_configuration(
        &self,
        period: u32,
        value_has_to_change: bool,
        option: char,
        min: u32,
        max: u32,
    ) -> ConvertingReceiver<()> {
        let mut payload = vec![0; 14];
        payload[0..4].copy_from_slice(&<u32>::to_le_byte_vec(period));
        payload[4..5].copy_from_slice(&<bool>::to_le_byte_vec(value_has_to_change));
        payload[5..6].copy_from_slice(&<char>::to_le_byte_vec(option));
        payload[6..10].copy_from_slice(&<u32>::to_le_byte_vec(min));
        payload[10..14].copy_from_slice(&<u32>::to_le_byte_vec(max));

        self.device.set(u8::from(Xmc1400BreakoutBrickletFunction::SetCountCallbackConfiguration), payload)
    }

    /// Returns the receiver configuration as set by [`set_count_callback_configuration`].
    ///
    /// Associated constants:
    /// * XMC1400_BREAKOUT_BRICKLET_THRESHOLD_OPTION_OFF
    ///	* XMC1400_BREAKOUT_BRICKLET_THRESHOLD_OPTION_OUTSIDE
    ///	* XMC1400_BREAKOUT_BRICKLET_THRESHOLD_OPTION_INSIDE
    ///	* XMC1400_BREAKOUT_BRICKLET_THRESHOLD_OPTION_SMALLER
    ///	* XMC1400_BREAKOUT_BRICKLET_THRESHOLD_OPTION_GREATER
    pub fn get_count_callback_configuration(&self) -> ConvertingReceiver<CountCallbackConfiguration> {
        let payload = vec![0; 0];

        self.device.get(u8::from(Xmc1400BreakoutBrickletFunction::GetCountCallbackConfiguration), payload)
    }

    /// Returns the error count for the communication between Brick and Bricklet.
    ///
    /// The errors are divided into
    ///
    /// * ACK checksum errors,
    /// * message checksum errors,
    /// * framing errors and
    /// * overflow errors.
    ///
    /// The errors counts are for errors that occur on the Bricklet side. All
    /// Bricks have a similar function that returns the errors on the Brick side.
    pub fn get_spitfp_error_count(&self) -> ConvertingReceiver<SpitfpErrorCount> {
        let payload = vec![0; 0];

        self.device.get(u8::from(Xmc1400BreakoutBrickletFunction::GetSpitfpErrorCount), payload)
    }

    /// Sets the bootloader mode and returns the status after the requested
    /// mode change was instigated.
    ///
    /// You can change from bootloader mode to firmware mode and vice versa. A change
    /// from bootloader mode to firmware mode will only take place if the entry function,
    /// device identifier and CRC are present and correct.
    ///
    /// This function is used by Brick Viewer during flashing. It should not be
    /// necessary to call it in a normal user program.
    ///
    /// Associated constants:
    /// * XMC1400_BREAKOUT_BRICKLET_BOOTLOADER_MODE_BOOTLOADER
    ///	* XMC1400_BREAKOUT_BRICKLET_BOOTLOADER_MODE_FIRMWARE
    ///	* XMC1400_BREAKOUT_BRICKLET_BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT
    ///	* XMC1400_BREAKOUT_BRICKLET_BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT
    ///	* XMC1400_BREAKOUT_BRICKLET_BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT
    ///	* XMC1400_BREAKOUT_BRICKLET_BOOTLOADER_STATUS_OK
    ///	* XMC1400_BREAKOUT_BRICKLET_BOOTLOADER_STATUS_INVALID_MODE
    ///	* XMC1400_BREAKOUT_BRICKLET_BOOTLOADER_STATUS_NO_CHANGE
    ///	* XMC1400_BREAKOUT_BRICKLET_BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT
    ///	* XMC1400_BREAKOUT_BRICKLET_BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT
    ///	* XMC1400_BREAKOUT_BRICKLET_BOOTLOADER_STATUS_CRC_MISMATCH
    pub fn set_bootloader_mode(&self, mode: u8) -> ConvertingReceiver<u8> {
        let mut payload = vec![0; 1];
        payload[0..1].copy_from_slice(&<u8>::to_le_byte_vec(mode));

        self.device.get(u8::from(Xmc1400BreakoutBrickletFunction::SetBootloaderMode), payload)
    }

    /// Returns the current bootloader mode, see [`set_bootloader_mode`].
    ///
    /// Associated constants:
    /// * XMC1400_BREAKOUT_BRICKLET_BOOTLOADER_MODE_BOOTLOADER
    ///	* XMC1400_BREAKOUT_BRICKLET_BOOTLOADER_MODE_FIRMWARE
    ///	* XMC1400_BREAKOUT_BRICKLET_BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT
    ///	* XMC1400_BREAKOUT_BRICKLET_BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT
    ///	* XMC1400_BREAKOUT_BRICKLET_BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT
    pub fn get_bootloader_mode(&self) -> ConvertingReceiver<u8> {
        let payload = vec![0; 0];

        self.device.get(u8::from(Xmc1400BreakoutBrickletFunction::GetBootloaderMode), payload)
    }

    /// Sets the firmware pointer for [`write_firmware`]. The pointer has
    /// to be increased by chunks of size 64. The data is written to flash
    /// every 4 chunks (which equals to one page of size 256).
    ///
    /// This function is used by Brick Viewer during flashing. It should not be
    /// necessary to call it in a normal user program.
    pub fn set_write_firmware_pointer(&self, pointer: u32) -> ConvertingReceiver<()> {
        let mut payload = vec![0; 4];
        payload[0..4].copy_from_slice(&<u32>::to_le_byte_vec(pointer));

        self.device.set(u8::from(Xmc1400BreakoutBrickletFunction::SetWriteFirmwarePointer), payload)
    }

    /// Writes 64 Bytes of firmware at the position as written by
    /// [`set_write_firmware_pointer`] before. The firmware is written
    /// to flash every 4 chunks.
    ///
    /// You can only write firmware in bootloader mode.
    ///
    /// This function is used by Brick Viewer during flashing. It should not be
    /// necessary to call it in a normal user program.
    pub fn write_firmware(&self, data: [u8; 64]) -> ConvertingReceiver<u8> {
        let mut payload = vec![0; 64];
        payload[0..64].copy_from_slice(&<[u8; 64]>::to_le_byte_vec(data));

        self.device.get(u8::from(Xmc1400BreakoutBrickletFunction::WriteFirmware), payload)
    }

    /// Sets the status LED configuration. By default the LED shows
    /// communication traffic between Brick and Bricklet, it flickers once
    /// for every 10 received data packets.
    ///
    /// You can also turn the LED permanently on/off or show a heartbeat.
    ///
    /// If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.
    ///
    /// Associated constants:
    /// * XMC1400_BREAKOUT_BRICKLET_STATUS_LED_CONFIG_OFF
    ///	* XMC1400_BREAKOUT_BRICKLET_STATUS_LED_CONFIG_ON
    ///	* XMC1400_BREAKOUT_BRICKLET_STATUS_LED_CONFIG_SHOW_HEARTBEAT
    ///	* XMC1400_BREAKOUT_BRICKLET_STATUS_LED_CONFIG_SHOW_STATUS
    pub fn set_status_led_config(&self, config: u8) -> ConvertingReceiver<()> {
        let mut payload = vec![0; 1];
        payload[0..1].copy_from_slice(&<u8>::to_le_byte_vec(config));

        self.device.set(u8::from(Xmc1400BreakoutBrickletFunction::SetStatusLedConfig), payload)
    }

    /// Returns the configuration as set by [`set_status_led_config`]
    ///
    /// Associated constants:
    /// * XMC1400_BREAKOUT_BRICKLET_STATUS_LED_CONFIG_OFF
    ///	* XMC1400_BREAKOUT_BRICKLET_STATUS_LED_CONFIG_ON
    ///	* XMC1400_BREAKOUT_BRICKLET_STATUS_LED_CONFIG_SHOW_HEARTBEAT
    ///	* XMC1400_BREAKOUT_BRICKLET_STATUS_LED_CONFIG_SHOW_STATUS
    pub fn get_status_led_config(&self) -> ConvertingReceiver<u8> {
        let payload = vec![0; 0];

        self.device.get(u8::from(Xmc1400BreakoutBrickletFunction::GetStatusLedConfig), payload)
    }

    /// Returns the temperature as measured inside the microcontroller. The
    /// value returned is not the ambient temperature!
    ///
    /// The temperature is only proportional to the real temperature and it has bad
    /// accuracy. Practically it is only useful as an indicator for
    /// temperature changes.
    pub fn get_chip_temperature(&self) -> ConvertingReceiver<i16> {
        let payload = vec![0; 0];

        self.device.get(u8::from(Xmc1400BreakoutBrickletFunction::GetChipTemperature), payload)
    }

    /// Calling this function will reset the Bricklet. All configurations
    /// will be lost.
    ///
    /// After a reset you have to create new device objects,
    /// calling functions on the existing ones will result in
    /// undefined behavior!
    pub fn reset(&self) -> ConvertingReceiver<()> {
        let payload = vec![0; 0];

        self.device.set(u8::from(Xmc1400BreakoutBrickletFunction::Reset), payload)
    }

    /// Writes a new UID into flash. If you want to set a new UID
    /// you have to decode the Base58 encoded UID string into an
    /// integer first.
    ///
    /// We recommend that you use Brick Viewer to change the UID.
    pub fn write_uid(&self, uid: u32) -> ConvertingReceiver<()> {
        let mut payload = vec![0; 4];
        payload[0..4].copy_from_slice(&<u32>::to_le_byte_vec(uid));

        self.device.set(u8::from(Xmc1400BreakoutBrickletFunction::WriteUid), payload)
    }

    /// Returns the current UID as an integer. Encode as
    /// Base58 to get the usual string version.
    pub fn read_uid(&self) -> ConvertingReceiver<u32> {
        let payload = vec![0; 0];

        self.device.get(u8::from(Xmc1400BreakoutBrickletFunction::ReadUid), payload)
    }

    /// Returns the UID, the UID where the Bricklet is connected to,
    /// the position, the hardware and firmware version as well as the
    /// device identifier.
    ///
    /// The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
    /// A Bricklet connected to an [Isolator Bricklet](isolator_bricklet) is always at
    /// position 'z'.
    ///
    /// The device identifier numbers can be found [here](device_identifier).
    /// |device_identifier_constant|
    pub fn get_identity(&self) -> ConvertingReceiver<Identity> {
        let payload = vec![0; 0];

        self.device.get(u8::from(Xmc1400BreakoutBrickletFunction::GetIdentity), payload)
    }
}
